module OHinCH where

import IOExts
import Concurrent

type O s t   = IORef s -> IO t

returnO     :: a -> O s a
returnO a    = \_ -> return a

bindO       :: O s a -> ( a -> O s b) -> O s b
e `bindO` f  = \v  -> do a <- e v
                         f a v 

get         :: O s s
get          = \v -> readIORef v

set         :: s -> O s ()
set s        = \v -> writeIORef v s

type Ref s   = Chan (O s ())

act         :: Ref s -> O s () -> O s' ()
act r c      = \_ -> writeChan r c

req         :: Ref s -> O s a -> O s' a
req r c      = \_ -> do ans <- newEmptyMVar
                        writeChan r 
                              (\v -> do a <- c v
                                        putMVar ans a)
                        takeMVar ans

objproc     :: IORef s -> Chan (O s ()) -> IO ()
objproc v r  = do c <- readChan r
                  c v
                  objproc v r

new         :: (Ref s -> s) -> (Ref s -> a) -> O s' a
new s iface  = \_ -> do r <- newChan 
                        v <- newIORef (s r)
                        forkIO (objproc v r)
                        return (iface r)
