
struct Counter =
    read  :: Request Int
    inc   :: Action

struct Counter2 < Counter =
    read2 :: Request Int

main env = do
  run counter
  run deadlock
  run deadlock2
  run2 reqfail
  env.putStr "Press any key, or 'q' to quit\n"
  inc
   
 where
  inctempl = template
                v := 0
             in
                \c -> action
                        if c == 'q' then env.quit
                        env.putStr (show v)
                        v := v+1

  inc = do n <- inctempl
           env.setReader n

  run proc   = do c <- proc
                  c.inc
                  c.inc
                  v <- c.read
                  env.putStr (show v)
                  env.putStr "\n"

  counter = template 
                x := 0
            in struct
                inc  = action 
                         x := x+1
                read = request 
                         return x


  deadlock = template
                  y <- counter
                  x := 0
             in let
                  me = struct
                          inc = action
                                   y.inc
                                   v <- me.read
                                   x := v+1
                          read = request
                                   return x
             in me
             handle
                  Deadlock -> env.putStr "deadlock detected\n"
                              v <- y.read
                              env.putStr ("y: " ++ show (v*100) ++ "\n")

  deadlock2 = template
                  x := 0
              in let
                  me = struct
                          inc = action
                                   v <- me.read
                                   x := v+1
                                handle
                                   Deadlock -> x := 35
                                   _        -> x := 19
                          read  = request
                                   return x
              in me

  reqfail    = template
                  x := 0
               in struct
                  inc = action
                      x := x+1
                  read = request
                      raise (FileError "readError")
                  read2 = request
                      return x
               handle
                  FileError _ -> x := -1
                  _           -> x := -2

  run2 proc  = do c <- proc
                  c.inc
                  c.inc
                  v <- do 
                          c.read
                       handle
                          FileError _ -> return 77
                          ReqAbort    -> return 88
                          _           -> return 101
                  env.putStr ("fake v: " ++ show v ++ "\n")
                  v <- c.read2
                  env.putStr ("real v: " ++ show v ++ "\n")
               handle
                  _ -> env.putStr "aborted\n"
