module Struct where

struct Apa a =
    x :: a
    y :: a

struct Bepa =
    z :: [Int]

x = "does not clash with selector x"

instance Show (Apa a) where
    showsPrec _ _ = showString "<<struct>>"
    
instance Show Bepa where
    showsPrec _ _ = showString "<<struct>>"
    
pad0 = let x = 1; y = 2 in struct .. Apa

pad1 = let x = 1 in struct y = 2 .. Apa

pad2 = let y = 1 in struct x = 1 .. Apa

pad3 = struct x = 1; y = 2 .. Apa

-- errpad = let y = 2 in struct .. Apa  -- really bad error message :-(

struct Fun a b =
    fun :: a -> b

s1 = {x = 1; y = 2}

s2 = {x = 'a'; y = 'b'}

s3 = {z = []}

s4 = {x = 1:s4.x; y = []}

s5 = {x = s1; y = {x = 0; y = ord s2.y}}

ex1 = head (map (.x) [s1,s1])

ex2 = map (\f -> f s1) [(.x),(.y)]

ms = {fun g [] = []; fun g (x:xs) = g x : ms.fun g xs}

class CTest a where
    mem1 :: a -> Int
    mem2 :: a -> b -> b
    mem2 _ = id

data D = A | B

instance CTest D where
    mem1 a = 1
    mem2 x = \y -> y

data E a = E

data F a = F a

data G a = G (a->Int)

data H a = H a (a->Int)

struct I a b c =
    i1 :: a b
    i2 :: (c -> Int,a Bool)

data J a = J (Fun a a)

data K a = K (Fun a Int -> Int)
type T a b = a b

data S1 a b c > [a b], Maybe c = S1 c

struct X a =
    xx :: a -> a

struct Y a < X Bool =
    yy :: a

struct Y' a < X a =
    yy' :: a
    
struct Z a < Y a, Y' Bool =
    zz :: X a

data Bool3 > Bool = Perhaps

f True    = 1
f False   = 2
f Perhaps = 3

e1 = f True
e2 = f False
e3 = f Perhaps

r1 = {xx = not}
r2 = {xx = not; yy = 'a'}
r3 = {xx = reverse; yy' = "abc"}
r4 = struct
        xx  = not
        yy  = 'a'
        yy' = False
        zz  = {xx=id}

e4 = r4.xx False
e5 = r4.yy
e6 = r4.yy'
e7 = r4.zz.xx '#'

g r v = r.xx v

e8  = g r1 False
e9  = g r2 False
e10 = g r3 r3.yy'
e11 = g r4 False

newtype F' a = F' a

struct Empty a b c
