import Tk

port :: Port
port = Port 1984


struct Client < UDPClient =
   xmit :: String -> Action

client :: StdEnv -> (String -> Cmd ()) -> UDPConnection -> Template Client
client env receiver con = 
   template 
     peer := Nothing
   in struct
          deliverUDP pkt = action
                            peer := Just pkt.peer
			    env.putStr "got packet"
			    let (host, Port port) = pkt.peer
			    env.udp.getNameOfHost host $ \hn -> action
			      env.putStr (" from " ++ hn ++ "(" ++ show port ++ ")" ++ ":" ++ pkt.contents ++ "\n")
                            receiver pkt.contents
          xmit s = action
              case peer of
                Just p -> con.sendUDP (struct peer=p;contents=s)
                _ -> env.putStr "Cannot send packet\n"

main env = do
   env.setReader (\c -> env.putStr ("got "++[c]++"\n"))
   win  <- env.window [Title "Udp Server"]
   lab  <- win.label  [Text "Nothing received"]
   fix c   <- client env (\s -> lab.set [Text ("Got "++s)]) con
       con <- env.udp.listenUDP port c
   let butt i = win.button [Text i, Command (c.xmit i)]
   b1 <- butt "Yes"
   b2 <- butt "No"
   quit <- win.button [Text "Quit", Foreground red, Command env.quit]
   pack (row [lab,b1,b2,quit])
